include:
  - /templates.gitlab-ci.yaml

  - /jobs/build.julia-1.0.gitlab-ci.yaml
  - /jobs/build.julia-1.1.gitlab-ci.yaml
  - /jobs/build.julia-1.2.gitlab-ci.yaml
  - /jobs/build.julia-1.3.gitlab-ci.yaml
  - /jobs/build.julia-1.4.gitlab-ci.yaml
  - /jobs/build.julia-1.5.gitlab-ci.yaml
  - /jobs/build.julia-1.6.gitlab-ci.yaml
  - /jobs/build.julia-1.7.gitlab-ci.yaml
  - /jobs/build.julia-1.8.gitlab-ci.yaml
  - /jobs/build.julia-1.9.gitlab-ci.yaml
  - /jobs/build.julia-1.gitlab-ci.yaml
  - /jobs/build.julia-lts.gitlab-ci.yaml
  - /jobs/build.julia-stable.gitlab-ci.yaml

  - /jobs/format.gitlab-ci.yaml

  - /jobs/test.julia-1.0.gitlab-ci.yaml
  - /jobs/test.julia-1.1.gitlab-ci.yaml
  - /jobs/test.julia-1.2.gitlab-ci.yaml
  - /jobs/test.julia-1.3.gitlab-ci.yaml
  - /jobs/test.julia-1.4.gitlab-ci.yaml
  - /jobs/test.julia-1.5.gitlab-ci.yaml
  - /jobs/test.julia-1.6.gitlab-ci.yaml
  - /jobs/test.julia-1.7.gitlab-ci.yaml
  - /jobs/test.julia-1.8.gitlab-ci.yaml
  - /jobs/test.julia-1.9.gitlab-ci.yaml
  - /jobs/test.julia-1.gitlab-ci.yaml
  - /jobs/test.julia-lts.gitlab-ci.yaml
  - /jobs/test.julia-stable.gitlab-ci.yaml

stages:
  - build
  - test

variables:
  CI_JULIA_PROJECT_PATH: examples/Sample

analyze_package:
  stage: test
  parallel:
    matrix:
      - CI_JULIA_JET_VERSION:
          - "0.9.12"
          - "latest"
        CI_JULIA_JET_MODE: ["basic", "typo"] # sound mode skipped - reports unanalyzed method call
        CI_JULIA_JET_TARGET_DEFINED_MODULES: ["false", "true"]
  trigger:
    include:
      - /templates.gitlab-ci.yaml
      - /jobs/analyze_package.gitlab-ci.yaml
    strategy: depend
  needs: []

analyze_tests:
  stage: test
  parallel:
    matrix:
      - CI_JULIA_JET_VERSION:
          - "0.9.12"
          - "latest"
        CI_JULIA_JET_ANALYZER: ["JET.JETAnalyzer"]
        CI_JULIA_JET_MODE: ["basic", "typo"] # sound mode skipped - reports errors in Julia Base
        CI_JULIA_JET_TARGET_DEFINED_MODULES: ["false", "true"]
      - CI_JULIA_JET_VERSION:
          - "0.9.12"
          - "latest"
        CI_JULIA_JET_ANALYZER: ["JET.OptAnalyzer"]
        CI_JULIA_JET_TARGET_DEFINED_MODULES: ["true"] # "false" reports errors in Julia Test
  except:
    variables:
      - $CI_JULIA_JET_ANALYZER == "JET.JETAnalyzer" && $CI_JULIA_JET_MODE == "basic" && $CI_JULIA_JET_TARGET_DEFINED_MODULES == "false" # reports errors in Julia Test
  trigger:
    include:
      - /templates.gitlab-ci.yaml
      - /jobs/analyze_tests.gitlab-ci.yaml
    strategy: depend
  needs: []

registries:
  stage: test
  parallel:
    matrix:
      - CI_JULIA_VERSION: ["1.0", "1.1", "1.2", "1.3", "1.4", "1.5", "1.6", "1.7", "1.8", "1.9", "1"]
        CI_JULIA_REGISTRIES: https://github.com/JuliaRegistries/Test.git
  trigger:
    include:
      - /templates.gitlab-ci.yaml
      - /jobs/test.gitlab-ci.yaml # This job requires packages from General, so the job will fail if General is not available
    strategy: depend
  needs: []

test_variants:
  stage: test
  parallel:
    matrix:
      - CI_JULIA_VERSION: ["1.0", "1.1", "1.2", "1.3", "1.4", "1.5", "1.6", "1.7", "1.8", "1.9", "1"]
        CI_JULIA_TEST_REPORTS: ["REPORTS_OFF", "REPORTS_ON"]
        CI_JULIA_TEST_THREADS: ["THREADS_OFF", "THREADS_ON"]
  except:
    variables:
      - $CI_JULIA_TEST_REPORTS == "REPORTS_ON" && $CI_JULIA_TEST_THREADS == "THREADS_ON"
  trigger:
    include:
      - /templates.gitlab-ci.yaml
      - /jobs/build.gitlab-ci.yaml
      - /jobs/test.needs_build.gitlab-ci.yaml
    strategy: depend
  needs: []
